/* de54du.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static doublereal c_b20 = 1.;

/* Subroutine */ int de54du_c(D_fp ff, D_fp fg, D_fp fr, integer *m,
        doublereal *xn, doublereal *yn, doublereal *xk, doublereal *hmin, 
        doublereal *eps, doublereal *p, doublereal *h__, doublereal *y, 
        doublereal *ra, integer *ierr)
{
    /* Initialized data */

    static doublereal zero = 0.;
    static doublereal p5 = .5;
    static doublereal op5 = 1.5;
    static doublereal three = 3.;
    static doublereal four = 4.;
    static doublereal e5 = 5e-5;

    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2;

    /* Builtin functions */
    double d_sign(doublereal *, doublereal *), sin(doublereal),
            cos(doublereal);

    /* Local variables */
    static doublereal rfsc, r1gsc, e;
    static integer i__, j;
    static doublereal q, r__, x, h3;
    static logical be, bh, br;
    static doublereal rc, rf, rg, hs;
    static logical bx;
    static doublereal rr, rs;
    static integer sw;
    static doublereal xs;
    static integer ib1, ib2;
    static doublereal rc2, rs2, rsc;
    static integer ijk0, ijk1, ijk2;

    /* Parameter adjustments */
    --yn;
    --y;
    --ra;

    /* Function Body */
    *ierr = 0;
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L1: */
        y[i__] = yn[i__];
    }
    if (*xn == *xk) {
        goto L23;
    }
    e5 = *eps * 5.;
    ib1 = *m + *m;
    ib2 = ib1 + *m;
    bh = TRUE_;
    br = TRUE_;
    bx = TRUE_;

    d__1 = abs(*h__);
    d__2 = *xk - *xn;
    *h__ = d_sign(&d__1, &d__2);
    x = *xn;
L2:
    xs = x;
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
        ijk0 = *m + j;
        ra[ijk0] = y[j];
/* L3: */
    }
L4:
    hs = *h__;
    q = x + *h__ - *xk;
    be = TRUE_;
    if (! (*h__ > zero && q >= zero || *h__ < zero && q <= zero)) {
        goto L5;
    }
    *h__ = *xk - x;
    br = FALSE_;
L5:
    h3 = *h__ / three;

    for (sw = 1; sw <= 5; ++sw) {
        rs = sin(y[1]);
        rc = cos(y[1]);
        rsc = rs * rc;
        rs2 = rs * rs;
        rc2 = 1. - rs2;
        rf = (*ff)(&x);
        rg = (*fg)(&x);
        rr = (*fr)(&x);
        rfsc = rf * rsc;
        r1gsc = rg * rc2;
        ra[1] = rs2 - rfsc + r1gsc;
        r1gsc = (1. - rg) * rsc;
        ra[2] = rr * rc - (rf * rc2 - r1gsc) * y[2];
        if (*m == 2) {
            goto L6;
        }
        ra[3] = ((1. - rg) * (rc2 - rs2) + rfsc + rfsc) * y[2] -
                (rf * rs2 + r1gsc) * y[3] - rr * rs;
L6:
        i__1 = *m;
        for (i__ = 1; i__ <= i__1; ++i__) {
            q = h3 * ra[i__];
            ijk0 = *m + i__;
            ijk1 = ib1 + i__;
            ijk2 = ib2 + i__;
            switch (sw) {
                case 1:  goto L7;
                case 2:  goto L8;
                case 3:  goto L9;
                case 4:  goto L10;
                case 5:  goto L11;
            }
L7:
            r__ = q;
            ra[ijk1] = q;
            goto L12;
L8:
            r__ = p5 * (q + ra[ijk1]);
            goto L12;
L9:
            r__ = three * q;
            ra[ijk2] = r__;
            r__ = (r__ + ra[ijk1]) * .375;
            goto L12;
L10:
            r__ = ra[ijk1] + four * q;
            ra[ijk1] = r__;
            r__ = op5 * (r__ - ra[ijk2]);
            goto L12;
L11:
            r__ = p5 * (q + ra[ijk1]);
            q = (d__1 = r__ + r__ - op5 * (q + ra[ijk2]), abs(d__1));
L12:
            y[i__] = ra[ijk0] + r__;
            if (sw != 5) {
                goto L16;
            }

            e = (d__1 = y[i__], abs(d__1));
            r__ = e5;
            if (e >= *p) {
                r__ = e * e5;
            }

            if (q < r__) {
                goto L15;
            }
            if (! bx) {
                goto L22;
            }
            br = TRUE_;
            bh = FALSE_;
            *h__ = p5 * *h__;
            if (abs(*h__) >= *hmin) {
                goto L13;
            }

            *h__ = d_sign(&c_b20, h__) * *hmin;
            bx = FALSE_;
L13:
            i__2 = *m;
            for (j = 1; j <= i__2; ++j) {
                ijk0 = *m + j;
                y[j] = ra[ijk0];
/* L14: */
            }
            x = xs;
            goto L4;
L15:
            if (q >= r__ * .03125) {
                be = FALSE_;
            }
L16:
            ;
        }
        switch (sw) {
            case 1:  goto L17;
            case 2:  goto L20;
            case 3:  goto L18;
            case 4:  goto L19;
            case 5:  goto L20;
        }
L17:
        x += h3;
        goto L20;
L18:
        x += p5 * h3;
        goto L20;
L19:
        x += p5 * *h__;
L20:
        ;
    }

    if (! (be && bh && br)) {
        goto L21;
    }
    *h__ += *h__;
    bx = TRUE_;
L21:
    bh = TRUE_;
    if (br) {
        goto L2;
    }
    *h__ = hs;
    goto L23;
L22:
    *ierr = 65;
L23:
    return 0;
} /* de54du_c */
